unit TestRVMedia;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, MRVCamRecorder, MRVType,
  MRVCamera, MRVBitmap, Vcl.ExtCtrls, Vcl.Imaging.jpeg;

type
  TRVMediaTest1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Timer1: TTimer;
    RVCamRecorder1: TRVCamRecorder;
    RVCamera1: TRVCamera;
    Image1: TImage;
    Button2: TButton;
    Label3: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure RVCamera1NewImage(Sender: TObject; img: TRVMBitmap);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
//    RVCamera1 : TRVCamera;
//    RVCamRecorder1 : TRVCamRecorder;
    FramesPerSecond : Integer;


  end;

var
RVMediaTest1: TRVMediaTest1;

implementation

{$R *.dfm}

procedure TRVMediaTest1.Button1Click(Sender: TObject);
begin
  RVCamRecorder1.VideoFramePerSec := StrToInt(Edit1.Text);
  RVCamRecorder1.Active := True;
  RVCamera1.PlayVideoStream;
  Timer1.Enabled := True;
end;


procedure TRVMediaTest1.Button2Click(Sender: TObject);
begin
  RVCamRecorder1.Active := False;
  RVCamera1.Abort;
  Timer1.Enabled := False;
end;

procedure TRVMediaTest1.FormCreate(Sender: TObject);
begin
//  RVCamera1 := TRVCamera.Create(nil);
//  RVCamRecorder1 := TRVCamRecorder.Create(nil);

  RVCamRecorder1.VideoSource := RVCamera1;
  RVCamRecorder1.VideoCodec := rvvcMPEG4;
  RVCamRecorder1.UseAudio := False;
  RVCamera1.onNewImage := RVCamera1NewImage;

  RVCamRecorder1.OutputFileName := 'Test.AVI';
  RVCamera1.DeviceType := rvdtUserData;

 end;


procedure TRVMediaTest1.RVCamera1NewImage(Sender: TObject; img: TRVMBitmap);
var i : Integer;
begin
  //
  Inc(FramesPerSecond);
  //
  // BURNIN TIME
  i := Image1.Picture.Bitmap.Width div 130;
  Image1.Picture.Bitmap.Canvas.Lock;
  Image1.Picture.Bitmap.Canvas.Font.Color := clRed;
  Image1.Picture.Bitmap.Canvas.Brush.Color := clWhite;
  Image1.Picture.Bitmap.Canvas.Font.Size := Image1.Picture.Bitmap.Width div 47;
  Image1.Picture.Bitmap.Canvas.Font.Style := [];
  Image1.Picture.Bitmap.Canvas.TextOut( 2*i, 2*i,
    FormatDateTime('h:nn:ss:zzz', Now ));
  Image1.Picture.Bitmap.Canvas.UnLock;
  //
  img.Assign(Image1.Picture.Bitmap);
end;


procedure TRVMediaTest1.Timer1Timer(Sender: TObject);
begin
  Label1.Caption := 'FramesPerSecond Written by ''''RVCamera.onNewImage'''' event: '+IntToStr(FramesPerSecond);
  FramesPerSecond := 0;
end;

end.





